<?php
session_start();
// include hybridauth lib
$config = dirname(__FILE__) . '/../../hybridauth/config.php';
require_once(dirname(__FILE__) . '/../../hybridauth/Hybrid/Auth.php');
try {
    $hybridauth = new Hybrid_Auth($config);
    $adapter = $hybridauth->getAdapter("twitter");
    $userConnected = $adapter->isUserConnected();
    if($_GET["action"] == "logout"){
        $adapter->logout();
        exit;
    }else if($_GET["action"] == "authenticate"){
        if(isset($_GET["prevUrl"])){
            $params["hauth_return_to"] = $_GET["prevUrl"];
        }
        if(!$userConnected){
            $adapter = $hybridauth->authenticate("twitter",$params);
            // recheck that user did not clicked on cancel
            $userConnected = $adapter->isUserConnected();
        }
    }
    if($userConnected){
        $user_activity = $adapter->getUserActivity( "timeline" );
    }
} catch (Exception $e) {
    die("<b>got an error!</b> " . $e->getMessage());
}
// logged in ?
if (!$userConnected || !isset($user_activity)) {
    $fullUrl = "/english/apis_src/hybridauth-2.1.2/examples/twitter_test/index.php?action=authenticate&prevUrl=". "http://guilgul.com/english/principal.php";//urlencode(currentPageURL());
    ?>
   <p>
    <a href ="<?php echo($fullUrl) ?>" ><img src="images/TwitterLogoColor.png" class='color' alt="Login Twitter"/><img src="images/TwitterLogoByN.png" class='nocolor' alt="Login Twitter"/> </a></h2>
 </p>
 <?php
}

else {
    ?>
     <table width="95%" border="0" cellpadding="2" cellspacing="2">
            <?php
            try{
                foreach( $user_activity as $item ){
                    ?>
                    <tr> 
                        <td align="left" valign="top" width="55" >  
                            <?php
                            if( $item->user->photoURL ){
                                ?>
                                <a href="<?php echo $item->user->profileURL; ?>"><img src="<?php echo $item->user->photoURL; ?>" border="0" width="48" height="48"></a>
                                <?php
                            }
                            else{
                                ?> 
                                <a href="<?php echo $item->user->profileURL; ?>"><img src="public/avatar.png" width="48" height="48" ></a>
                                <?php
                            } 
                            ?>  
                        </td>
                        <td align="left">  
                            <a href="<?php echo $item->user->profileURL; ?>"><b><?php echo $item->user->displayName; ?></b></a><br/>
                            <?php echo format_string( $item->text ); ?>
                            <br /><small><?php echo timestamp_to_relative_time( $item->date ); ?></small>
                            <hr />
                        </td>
                    </tr> 
                    <?php
                }

                if( ! count( $user_activity ) ){
                    echo "No activity found!";
                }
            }
            catch( Exception $e ){
        // if code 8 => Provider does not support this feature
                if( $e->getCode() == 8 ){
                    echo "Provider does not support this feature. Currently only <b>Facebook, MySpace, Twitter and LinkedIn</b> do support this!
                    <br />Please refer to the user guide to know more about each adapters capabilities. <a href='http://hybridauth.sourceforge.net/userguide.html'>http://hybridauth.sourceforge.net/userguide.html</a>";
                }
                else{
                    echo "Well, got an error: " . $e->getMessage();
                } 
            } 
            ?>
        </table>
    <?php
}

// extra fuction: should be put in util class

/*function currentPageURL() {
    $pageURL = 'http';
    if ($_SERVER["HTTPS"] == "on") {
        $pageURL .= "s";
    }
    $pageURL .= "://";
    if ($_SERVER["SERVER_PORT"] != "80") {
        $pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
    } else {
        $pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
    }
    return $pageURL;
}

//FUNCIONES DEL ARCHIVO COMMON.PHP

function timestamp_to_relative_time( $dt )
    {
        $precision = 2;
        $times=array(   365*24*60*60    => "year",
                30*24*60*60 => "month",
                7*24*60*60  => "week",
                24*60*60    => "day",
                60*60       => "hour",
                60      => "minute",
                1       => "second");

        $passed=time()-$dt;

        if($passed<5)
        {
            $output='less than 5 seconds ago';
        }
        else
        {
            $output=array();
            $exit=0;
            foreach($times as $period=>$name)
            {
                if($exit>=$precision || ($exit>0 && $period<60))    break;
                $result = floor($passed/$period);

                if($result>0)
                {
                    $output[]=$result.' '.$name.($result==1?'':'s');
                    $passed-=$result*$period;
                    $exit++;
                }

                else if($exit>0) $exit++;

            }
            $output=implode(' and ',$output).' ago';
        }

        return $output;
    }

    // format message
    function format_string( $string )
    {
        // url to link
        $string = preg_replace( '/((?:http|https|ftp):\/\/(?:[A-Z0-9][A-Z0-9_-]*(?:\.[A-Z0-9][A-Z0-9_-]*)+):?(\d+)?\/?[^\s\"\']+)/i','<a href="$1" rel="nofollow" target="blank">$1</a>', $string ) ;

    // some stuff for twitter, just to demonstrate ...

        // hashtag to link
        $string = preg_replace('/(^|\s)#(\w*[a-zA-Z_]+\w*)/', '\1<a href="http://twitter.com/search/\2" rel="nofollow" target="blank">#\2</a>', $string );
        
        // @ to link
        $string = preg_replace('/(^|\s)@(\w*[a-zA-Z_]+\w*)/', '\1<a href="http://twitter.com/\2" rel="nofollow" target="blank">@\2</a>', $string );

        return $string;
    }*/
    ?>
